- Main Page
- Namespaces
- Classes
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# BuddhaLib::Matrix Struct Reference

４×４行列 More...

`#include <BuddhaMatrix.h>`

List of all members.

## Static Public Member Functions
static void | CreateD3DXMatrix (const Matrix &in, D3DMATRIX &out)
| Matrix型をD3DMATRIX型に変換する.
static void | CreateFromD3DXMatrix (const D3DMATRIX &in, Matrix &out)
| D3DMATRIX型をMatrix型に変換する.
static Matrix | CreateLookAt (const Vector3 &from, const Vector3 &to, const Vector3 &up)
| 視点座標と注視点座標を指定してビュー行列を作成する
static Matrix | CreatePerspectiveFieldOfView (FLOAT fieldOfView, FLOAT aspectRatio, FLOAT nearPlaneDistance, FLOAT farPlaneDistance)
| 射影行列を作成して返す
static void | CreatePerspectiveFieldOfView (FLOAT fieldOfView, FLOAT aspectRatio, FLOAT nearPlaneDistance, FLOAT farPlaneDistance, Matrix &result)
| 射影行列を作成する
static void | CreateRotationX (FLOAT radians, Matrix &out)
| X軸の回転マトリクスを作成する.
static Matrix | CreateRotationX (FLOAT radians)
| X軸の回転マトリクスを作成して返す.
static void | CreateRotationY (FLOAT radians, Matrix &out)
| Y軸の回転マトリクスを作成する.
static Matrix | CreateRotationY (FLOAT radians)
| Y軸の回転マトリクスを作成して返す.
static void | CreateRotationZ (FLOAT radians, Matrix &out)
| Z軸の回転マトリクスを作成する.
static Matrix | CreateRotationZ (FLOAT radians)
| Z軸の回転マトリクスを作成して返す.
static void | CreateScale (const FLOAT sx, const FLOAT sy, const FLOAT sz, Matrix &out)
| スケーリングマトリクスを作成する
static void | CreateScale (const FLOAT scale, Matrix &out)
| スケーリングマトリクスを作成する
static Matrix | CreateScale (const FLOAT sx, const FLOAT sy, const FLOAT sz)
| スケーリングマトリクスを作成して返す
static Matrix | CreateScale (const FLOAT scale)
| スケーリングマトリクスを作成して返す
static Matrix | CreateScale (const Vector3 &vec)
| スケーリングマトリクスを作成して返す
static void | CreateTransform (const FLOAT x, const FLOAT y, const FLOAT z, Matrix &out)
| トランスフォーム行列を作成する
static Matrix | CreateTransform (const FLOAT x, const FLOAT y, const FLOAT z)
| トランスフォーム行列を作成して返す
static Matrix | CreateTransform (const Vector3 &vec)
| トランスフォーム行列を作成して返す
static void | Multiply (const Matrix &mat1, const Matrix &mat2, Matrix &result)
| 行列を合成する
static Matrix | Multiply (const Matrix &mat1, const Matrix &mat2)
| 行列を合成して返す
static void | CreateFromQuaternion (const Quaternion &quaternion, Matrix &out)
| クォータニオンから回転マトリクスを作成する
static Matrix | CreateFromQuaternion (const Quaternion &quaternion)
| クォータニオンから回転マトリクスを作成して返す
static Matrix | CreateBillboard (const Vector3 &objectPosition, const Vector3 &cameraPosition, const Vector3 &cameraUpVector)
| 指定されたオブジェクト座標の周りをカメラ方向へ回転するビルボードを作成します。
static void | CreateBillboard (const Vector3 &objectPosition, const Vector3 &cameraPosition, const Vector3 &cameraUpVector, Matrix &result)
| 指定されたオブジェクト座標の周りをカメラ方向へ回転するビルボードを作成します。
## Public Attributes
FLOAT | M11
| １行１列の値
FLOAT | M12
| １行２列の値
FLOAT | M13
| １行３列の値
FLOAT | M14
| １行４列の値
FLOAT | M21
| ２行１列の値
FLOAT | M22
| ２行２列の値
FLOAT | M23
| ２行３列の値
FLOAT | M24
| ２行４列の値
FLOAT | M31
| ３行１列の値
FLOAT | M32
| ３行２列の値
FLOAT | M33
| ３行３列の値
FLOAT | M34
| ３行４列の値
FLOAT | M41
| ４行１列の値
FLOAT | M42
| ４行２列の値
FLOAT | M43
| ４行３列の値
FLOAT | M44
| ４行４列の値

## Detailed Description

４×４行列

## Member Function Documentation

static void BuddhaLib::Matrix::CreateFromD3DXMatrix | ( | const D3DMATRIX & | in,
|  | Matrix & | out |
| ) |  |  | `[inline, static]`

D3DMATRIX型をMatrix型に変換する.

Remarks:
  代入演算でも行うことができるが、将来的に BuddhaLib が DirectX への依存性を なくす場合（あるんか？）を考慮に入れて、このユーティリティ関数を使うべきである。

Matrix BuddhaLib::Matrix::CreateLookAt | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | const Vector3 & | up |
| ) |  |  | `[static]`

視点座標と注視点座標を指定してビュー行列を作成する

Todo:
  自前演算を行う

Matrix BuddhaLib::Matrix::CreateBillboard | ( | const Vector3 & | objectPosition,
|  | const Vector3 & | cameraPosition,
|  | const Vector3 & | cameraUpVector |
| ) |  |  | `[static]`

指定されたオブジェクト座標の周りをカメラ方向へ回転するビルボードを作成します。

Parameters:

  | objectPosition | オブジェクト座標
  | cameraPosition | カメラ座標
  | cameraUpVector | カメラの上方向へのベクトル

Returns:
  ビルボード回転マトリクス

void BuddhaLib::Matrix::CreateBillboard | ( | const Vector3 & | objectPosition,
|  | const Vector3 & | cameraPosition,
|  | const Vector3 & | cameraUpVector,
|  | Matrix & | result |
| ) |  |  | `[static]`

指定されたオブジェクト座標の周りをカメラ方向へ回転するビルボードを作成します。

Parameters:

  | objectPosition | オブジェクト座標
  | cameraPosition | カメラ座標
  | cameraUpVector | カメラの上方向へのベクトル
  | result | 結果を受け取るマトリクスへの参照

Returns:
  ビルボード回転マトリクス

Todo:
  DXヘルパ関数を使っているので、あとで公式で修正する